#include <stdio.h>
#include <proto/datatypes.h>
#include <datatypes/pictureclass.h>

#undef PICTURE_ONLY

int main(void)
{
	struct DataType *dt = NULL, *prevdt = NULL;
	struct BitMapHeader *bmhd;
	Object *dto;
	char fname[100];
	int err;

	while(dt = IDataTypes->ObtainDataType(DTST_RAM, NULL,
#ifdef PICTURE_ONLY
				DTA_GroupID, GID_PICTURE,
#endif
				DTA_DataType, dt,
				TAG_DONE))
	{
		sprintf(fname, "ram:test.%s", dt->dtn_Header->dth_Name);
	//	printf("%s\n", dt->dtn_Header->dth_Name);

		if(dto = IDataTypes->NewDTObject(NULL,
					DTA_SourceType, DTST_RAM,
					DTA_DataType, dt,
#ifdef PICTURE_ONLY
					DTA_GroupID, GID_PICTURE,
					PDTA_DestMode, PMODE_V43,
#endif
					TAG_DONE))
		{
#ifdef PICTURE_ONLY
			if(IDataTypes->GetDTAttrs(dto, PDTA_BitMapHeader, &bmhd, TAG_DONE))
			{
				bmhd->bmh_Width = (UWORD)1;
				bmhd->bmh_Height = (UWORD)1;
				bmhd->bmh_Depth = 32;
				bmhd->bmh_Masking = mskHasAlpha; /* assume alpha as 32-bit */
			}
#endif
			IDataTypes->SetDTAttrs(dto, NULL, NULL,
				DTA_ObjAnnotation, "Created by DTM_WRITE test",
				DTA_NominalHoriz, 1,
				DTA_NominalVert, 1,
				PDTA_SourceMode, PMODE_V43,
				TAG_DONE);

			err = IDataTypes->SaveDTObjectA(dto, NULL, NULL, fname, DTWM_RAW, FALSE, NULL);

			printf("%s: %ld\n",dt->dtn_Header->dth_Name, err);

			IDataTypes->DisposeDTObject(dto);
	    }
		if(prevdt) IDataTypes->ReleaseDataType(prevdt);
		prevdt = dt;
	}
	return 0;
}
